changes for buster linode
[distro-setup] / brc
diff --git a/brc b/brc
index f0ae687d29cd6173c4735e937d1b96d8a23daf99..9fff367476d4fb1413831f1f4255e6f5be113f53 100644 (file)
--- a/brc
+++ b/brc
@@ -26,9 +26,7 @@ unalias -a
 shopt -s extglob
 # include .files when globbing, but ignore files name . and ..
 # setting this also sets dotglob.
-# Note, this doesnt work in bash 4.4 anymore, for paths with
-# more than 1 directory, like a/b/.foo, since * is fixed to not match /
-export GLOBIGNORE=*/.:*/..
+export GLOBIGNORE="*/.:*/.."
 
 # broken with bash_completion package. Saw a bug for this once. dont anymore.
 # still broken in wheezy
@@ -61,7 +59,7 @@ shopt -s cmdhist
 shopt -s globstar
 
 
-# inside emcas fixes
+# inside emacs fixes
 if [[ $RLC_INSIDE_EMACS ]]; then
   # EMACS is used by bash on startup, but we dont need it anymore.
   # plus I hit a bug in a makefile which inherited it
@@ -96,6 +94,19 @@ if [[ $RLC_INSIDE_EMACS ]]; then
 
 fi
 
+# emacs has a different default search path than the info command. This
+# adds the info defaults to emacs, but not the reverse, because I dun
+# care much about the cli. The search path is only on the cli if you run
+# "info xxx", or in emacs if you run '(info xxx)', so not that
+# important, but might as well fix it.
+
+# info info says this path is what was compiled, and its not documented
+# anywhere. Through source grepping, i found it in filesys.h of the info
+# source in trisquel flidas.
+#
+# Traling : means for emacs to add its own stuff on to the end.
+
+export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
 
 if [[ $- == *i* ]]; then
   # for readline-complete.el
@@ -107,12 +118,16 @@ if [[ $- == *i* ]]; then
     bind '"\C-i": self-insert'
   else
 
+    if [[ $KONSOLE_PROFILE_NAME ]]; then
+      TERM=xterm-256color
+    fi
+
     # todo: not sure this works in sakura
     #stty werase undef
     #bind "\C-w": kill-region
     # sakura == xterm-256color
     # konsole == xterm
-    if [[ $TERM == "xterm" ]]; then
+    if [[ $TERM == xterm* ]]; then
       # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
       bind '"\e[1;5C": shell-forward-word' 2>/dev/null
       bind '"\e[1;5D": shell-backward-word' 2>/dev/null
@@ -153,38 +168,51 @@ HISTCONTROL=ignoredups
 # works in addition to HISTCONTROL to do more flexible things
 # it could also do the same things as HISTCONTROL and thus replace it,
 # but meh. dunno why, but just " *" does glob expansion, so use [ ] to avoid it.
-HISTIGNORE='pass *:[ ]*:lom*:gram*'
+HISTIGNORE='pass *:[ ]*:otp *:oathtool *'
 
 export BC_LINE_LENGTH=0
 
+export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
 
 # note, if I use a machine I dont want files readable by all users, set
 # umask 077  # If fewer than 4 digits are entered, leading zeros are assumed
 
-C_DEFAULT_DIR=/a
-
 # i for insensitive. the rest from
-# https://superuser.com/questions/366930/how-do-i-get-the-git-pager-to-clean-up-screen-output-after-exit
-# and reading the man
+# X means dont remove the current screenworth of output upon exit
+# R means to show colors n things
 export LESS=RXi
 export SYSTEMD_LESS=$LESS
 
 # * include files
-for _x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do
-  source "$_x"
-done
-unset _x
-# so I can share my bashrc
-for x in /a/bin/bash_unpublished/source-!(.#*); do source $x; done
+
+# generated instead of dynamic for the benefit of shellcheck
+#for x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do echo source $x ; done
+source /a/bin/distro-functions/src/identify-distros
+source /a/bin/distro-functions/src/package-manager-abstractions
+source /a/bin/distro-setup/path_add-function
+source /a/bin/ds/path_add-function
+source /a/bin/log-quiet/logq-function
+source /a/bin/small-misc-bash/ll-function
+source /a/bin/small-misc-bash/psg-function
+# for x in /a/bin/bash_unpublished/source-!(.#*); do echo source $x; done
+source /a/bin/bash_unpublished/source-semi-priv
+source /a/bin/bash_unpublished/source-state
+
+# shellcheck source=./path_add-function
 source $(dirname $(readlink -f $BASH_SOURCE))/path_add-function
 source /a/bin/log-quiet/logq-function
-if [[ -e /a/bin/errhandle/err ]]; then
-  source /a/bin/errhandle/err
-  err-allow
-fi
-# if someone exported $SOE (stop on error), catch errors
+# if someone exported $SOE (stop on error), catch errors.
+#
+# Note, on debian this results in the following warning when in ssh,
+# hich I haven't figured out how to fix. It doesn't happen if we source
+# after the shell has started
+#
+# bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
+# bash: warning: cannot start debugger; debugging mode disabled
 if [[ $SOE ]]; then
-  err-catch
+  if [[ -e /a/bin/errhandle/err ]]; then
+    source /a/bin/errhandle/err
+  fi
 fi
 
 path_add /a/exe
@@ -195,11 +223,12 @@ path_add /a/exe
 path_add --end ~/.local/bin
 path_add --ifexists --end /a/work/libremanage
 path_add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
-path_add --ifexists --end /a/opt/scancode-toolkit-2.9.2
+path_add --ifexists --end /a/opt/scancode-toolkit-3.0.2
 export WCDHOME=/a
 # based on readme.debian. dunno if this will break on other distros.
-_x=/usr/share/wcd/wcd-include.sh
-if [[ -e $_x ]]; then source $_x; fi
+if [[ -s /usr/share/wcd/wcd-include.sh ]]; then
+  source /usr/share/wcd/wcd-include.sh
+fi
 
 
 # * aliases
@@ -240,9 +269,9 @@ unalias ls ll grep &>/dev/null ||:
 
 # file cut copy and paste, like the text buffers :)
 # I havnt tested these.
-_fbufferinit() { # internal use by
+_fbufferinit() { # internal use
   ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
-  rm -rf "$my_f_tempdir"/*
+  rm -rf "${my_f_tempdir:?}"/*
 }
 fcp() { # file cp
   _fbufferinit
@@ -266,7 +295,7 @@ complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
 _cdiff-prep() {
   # join options which are continued to multiples lines onto one line
   local first=true
-  grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
+  while IFS= read -r line; do
     # remove leading spaces/tabs. assumes extglob
     if [[ $line == "[  ]*" ]]; then
       line="${line##+( )}"
@@ -280,7 +309,7 @@ _cdiff-prep() {
     else
       pastline="$pastline $line"
     fi
-  done
+  done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
   echo "$pastline" >> "$2"
 }
 
@@ -313,7 +342,8 @@ khcopy() {
 }
 
 a() {
-  local x=$(readlink -nf "${1:-$PWD}")
+  local x
+  x=$(readlink -nf "${1:-$PWD}")
   # yes, its kinda dumb that xclip/xsel cant do this in one invocation
   echo -n "$x" | xclip -selection clipboard
   echo -n "$x" | xclip
@@ -361,19 +391,19 @@ b() {
 bbk() {
   c /
   local active=true
-  if systemctl is-active btrbk.service; then
-    echo "cron btrbk is already running"
-    return 1
-  fi
   systemctl is-active btrbk.timer || active=false
   if $active; then
     ser disable btrbk.timer
   fi
+  if systemctl is-active btrbk.service; then
+    $active && ser enable btrbk.timer
+    echo "cron btrbk is already running"
+    return 1
+  fi
   # run latest
   install-my-scripts
-  if ! btrbk-run "$@" && $active; then
-    ser enable btrbk.timer
-  fi
+  btrbk-run "$@"
+  $active && ser enable btrbk.timer
 }
 
 bfg() { java -jar /a/opt/bfg-1.12.14.jar "$@"; }
@@ -396,6 +426,14 @@ bpush() {
   install-my-scripts
   switch-mail-host $HOSTNAME $1
 }
+lipush() {
+  rsync $@ --delete-excluded -ahviSAXPH --specials --devices --delete --relative \
+        --exclude-from=/p/c/li-rsync-excludes /a/bin /a/exe /a/h /a/c /p/c/machine_specific/li /a/opt/{emacs,emacs-debianstable,mu} root@li:/
+}
+lipushnoe() {
+  rsync $@ --delete-excluded -ahviSAXPH --specials --devices --delete --relative \
+        --exclude-from=/p/c/li-rsync-excludes /a/bin /a/exe /a/h /a/c /p/c/machine_specific/li  root@li:/
+}
 
 
 btc() {
@@ -444,6 +482,7 @@ fi
 caa() { git commit --amend --no-edit -a; }
 
 caf() {
+  # shellcheck disable=SC2033
   find -L $1 -type f -not \( -name .svn -prune -o -name .git -prune \
        -o -name .hg -prune -o -name .editor-backups -prune \
        -o -name .undo-tree-history -prune \) \
@@ -474,10 +513,10 @@ cdiff() {
   # setup for format of postfix, eg:
   # option = stuff[,]
   #    [more stuff]
-  local pastline
-  local unified="$(mktemp)"
-  local f1="$(mktemp)"
-  local f2="$(mktemp)"
+  local pastline unified f1 f2
+  unified="$(mktemp)"
+  f1="$(mktemp)"
+  f2="$(mktemp)"
   _cdiff-prep "$1" "$f1"
   _cdiff-prep "$2" "$f2"
   cat "$f1" "$f2" |  grep -Po '^[^=]+=' | sort | uniq > "$unified"
@@ -509,7 +548,8 @@ cat-new-files() {
   local start=$SECONDS
   local dir="$1"
   inotifywait -m "$dir" -e create -e moved_to |
-    while read filedir _ file; do
+    # shellcheck disable=SC2030
+    while read -r filedir _ file; do
       cat "$filedir$file"
       hr
       calc $((SECONDS - start)) / 60
@@ -518,6 +558,7 @@ cat-new-files() {
 
 }
 
+# shellcheck disable=SC2032
 chown() {
   # makes it so chown -R symlink affects the symlink and its target.
   if [[ $1 == -R ]]; then
@@ -558,7 +599,7 @@ da() { # do all
   local host
   "$@"
   for host in x2 tp kd; do
-    ssh $host "$@"
+    ssh $host $(printf "")
   done
 }
 
@@ -577,7 +618,8 @@ debian_pick_mirror () {
   # this is idempotent. the only way to identify debian sources is to
   # note the original server, so we put it in a comment so we can
   # identify it later.
-  local file=$(mktemp -d)/f # safe way to get file name without creating one
+  local file
+  file=$(mktemp -d)/f # safe way to get file name without creating one
   sudo netselect-apt -o "$file" || return 1
   url=$(grep ^\\w $file | head -n1 | awk '{print $2}')
   sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
@@ -605,6 +647,12 @@ dus() { # du, sorted, default arg of
 
 e() { echo "$@"; }
 
+# echo var. print var including escapes, etc
+ev() {
+  printf "%qEOL\n" "${!1}"
+  printf "%s" "${!1}" |& hexdump -C
+}
+
 
 ediff() {
   [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
@@ -623,9 +671,13 @@ envload() { # load environment from a previous: export > file
 
 # mail related
 etail() {
-  sudo tail -f /var/log/exim4/mainlog
+  tail -F /var/log/exim4/mainlog -n 200
+}
+eless() {
+  less /var/log/exim4/mainlog
 }
 
+# shellcheck disable=SC2032
 f() {
   # cd forward
   c +
@@ -641,9 +693,9 @@ fa() {
 }
 
 faf() { # find all files
-  find -L $1 -type f -not \( -name .svn -prune -o -name .git -prune \
+  find -L $1 -not \( -name .svn -prune -o -name .git -prune \
        -o -name .hg -prune -o -name .editor-backups -prune \
-       -o -name .undo-tree-history -prune \) 2>/dev/null
+       -o -name .undo-tree-history -prune \) -type f 2>/dev/null
 }
 
 # one that comes with distros is too old for newer devices
@@ -725,7 +777,7 @@ fdup() {
   local p
   fdroidcl update
   if fdroidcl search -u | grep ^org.fdroid.fdroid; then
-    fdroidcl upgrade org.fdroid.fdroid
+    fdroidcl install org.fdroid.fdroid
     sleep 5
     fdroidcl update
   fi
@@ -744,7 +796,7 @@ fdup() {
   done
   for p in ${!installed[@]}; do
     if ! ${updated[$p]:-true}; then
-      fdroidcl upgrade $p
+      fdroidcl install $p
       sleep 5
     fi
   done
@@ -797,7 +849,7 @@ fsdiff () {
       echo "$line" >> "$m"
       msize=$((msize + 1))
     fi
-  done < <(find -type f )
+  done < <(find -type f )
   if $missing; then
     echo "$m"
     (( msize <= 100 )) && cat $m
@@ -813,7 +865,8 @@ fsdiff-test() {
   echo nok > b
   mkdir c
   echo ok > c/d
-  local x=$(mktemp -d)
+  local x
+  x=$(mktemp -d)
   mkdir $x/c
   echo different > $x/c/d
   echo ok > $x/a
@@ -899,7 +952,8 @@ Output the directory of PATH, or just PATH if it is a directory."
   if [[ -d $1 ]]; then
     echo "$1"
   else
-    local dir="$(dirname "$1")"
+    local dir
+    dir="$(dirname "$1")"
     if [[ -d $dir ]]; then
       echo "$dir"
     else
@@ -911,14 +965,15 @@ Output the directory of PATH, or just PATH if it is a directory."
 
 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
   [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
-  local gitroot
-  gitroot || return 1 # function to set gitroot
-  builtin cd "$gitroot"
+  local root
+  root=$(gitroot) || return 1 # function to set gitroot
+  builtin cd "$root"
   git symbolic-ref HEAD refs/heads/$1
   rm .git/index
   git clean -fdx
 }
 
+# shellcheck disable=SC2120
 gitroot() {
   local help="Usage: gitroot [--help]
 Print the full path to the root of the current git repo
@@ -929,7 +984,8 @@ and works in older versions of git which did not have that."
     echo "$help"
     return
   fi
-  local p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
+  local p
+  p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
   [[ $p != /* ]] && p=$PWD
   echo "${p%%/.git}"
 }
@@ -941,7 +997,7 @@ gitian() {
 gh() {
   # i got an error, gh not found when doing a pull request, it seems like it wants itself in it\'s path.
   local _oldpath="$PATH"
-  PATH="$PATH:~/node_modules/.bin"
+  PATH="$PATH:$HOME/node_modules/.bin"
   command gh "$@"
   PATH="$_oldpath"
 }
@@ -981,13 +1037,15 @@ grr() { # grep recursive
     grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -RiIP --color=auto "$@"
   fi
 }
+rg() {
+  command rg -i -M 200 "$@"
+}
 
 hstatus() {
   # do git status on published repos
   cd /a/bin/githtml
-  do_hr=false
   for x in *; do
-    cd `readlink -f $x`/..
+    cd $(readlink -f $x)/..
     status=$(i status -s) || pwd
     if [[ $status ]]; then
       hr
@@ -1000,11 +1058,11 @@ hstatus() {
 
 hl() { # history limit. Write extra history to archive file.
   # todo: this is not working or not used currently
-  local max_lines linecount tempfile prune_lines x
+  local max_lines linecount prune_lines x
   local harchive="${HISTFILE}_archive"
   for x in "$HISTFILE" "$harchive"; do
     [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
-    if  [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID  ]];  then
+    if  [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != "$EUID"  ]];  then
       echo "error in hl: history file \$x:$x no good"
       return 1
     fi
@@ -1014,8 +1072,8 @@ hl() { # history limit. Write extra history to archive file.
   [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
   linecount=$(wc -l < $HISTFILE) # pipe so it doesnt output a filename
   [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
-  if (($linecount > $max_lines)); then
-    prune_lines=$(($linecount - $max_lines))
+  if ((linecount > max_lines)); then
+    prune_lines=$((linecount - max_lines))
     head -n $prune_lines "$HISTFILE" >> "$harchive" \
       && sed --follow-symlinks -ie "1,${prune_lines}d"  $HISTFILE
   fi
@@ -1092,30 +1150,14 @@ ifn() {
 }
 
 
-if [[ $OS == Windows_NT ]]; then
-  # cygstart wrapper
-  cs() {
-    cygstart "$@" &
-  }
-  xp() {
-    explorer.exe .
-  }
-  # launch
-  o() {
-    local x=(*$1*)
-    (( ${#x[#]} > 1 )) && { echo "warning ${#x[#]} matches found"; sleep 1; }
-    cygstart *$1* &
-  }
-else
-  o() {
-    if type gvfs-open &> /dev/null ; then
-      gvfs-open "$@"
-    else
-      xdg-open "$@"
-    fi
-    # another alternative is run-mailcap
-  }
-fi
+o() {
+  if type gvfs-open &> /dev/null ; then
+    gvfs-open "$@"
+  else
+    xdg-open "$@"
+  fi
+  # another alternative is run-mailcap
+}
 
 ipdrop() {
   s iptables -A INPUT -s $1 -j DROP
@@ -1202,7 +1244,7 @@ lower() { # make first letter of filenames lowercase.
   local x
   for x in "$@"; do
     if [[ ${x::1} == [A-Z] ]]; then
-      y=$(tr "[A-Z]" "[a-z]" <<<"${x::1}")"${x:1}"
+      y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
       safe_rename "$x" "$y" || return 1
     fi
   done
@@ -1224,9 +1266,9 @@ make-targets() {
 }
 
 mbenable() {
-  mb=$1
-  dst=/m/4e/$1
-  src=/m/md/$1
+  local mb=$1
+  dst=/m/4e/$mb
+  src=/m/md/$mb
   set -x
   [[ -e $src ]] || { set +x; return 1; }
   mv -T $src $dst || { set +x; return 1; }
@@ -1236,9 +1278,9 @@ mbenable() {
   set +x
 }
 mbdisable() {
-  mb=$1
-  dst=/m/md/$1
-  src=/m/4e/$1
+  local mb=$1
+  dst=/m/md/$mb
+  src=/m/4e/$mb
   set -x
   [[ -e $src ]] || { set +x; return 1; }
   if [[ -L $dst ]]; then rm $dst; fi
@@ -1259,7 +1301,7 @@ mkc() {
 }
 
 mkct() {
-  mkc `mktemp -d`
+  mkc $(mktemp -d)
 }
 
 mkt() { # mkdir and touch file
@@ -1268,6 +1310,7 @@ mkt() { # mkdir and touch file
   touch "$path"
 }
 
+# shellcheck disable=SC2032
 mkdir() { command mkdir -p "$@"; }
 
 mo() { xset dpms force off; } # monitor off
@@ -1282,7 +1325,22 @@ net-dev-info() {
 
 }
 
+nk() {
+  ser stop NetworkManager
+  ser stop dnsmasq
+  s resolvconf -d NetworkManager
+  ser start dnsmasq
+  s ifup br0
+}
+ngo() {
+  s ifdown br0
+  ser start NetworkManager
+  sleep 4
+  s nmtui-connect
+}
+
 nopanic() {
+  # shellcheck disable=SC2024
   sudo tee -a /var/log/exim4/paniclog-archive </var/log/exim4/paniclog; sudo truncate -s0 /var/log/exim4/paniclog
 }
 
@@ -1307,15 +1365,17 @@ pfind() { #find *$1* in $PATH
 }
 
 pkx() { # package extract
-  c `mktemp -d`
+  local pkg cached tmp f
+  c $(mktemp -d)
   pkg=$1
+  # shellcheck disable=SC2012
   cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1)
   if [[ $cached ]]; then
     cp $cached .
   else
     aptitude download $pkg
   fi
-  f=(*)
+  tmp=(*); f=${tmp[0]} # only 1 expected
   ex $f
   rm -f $f
 }
@@ -1325,8 +1385,11 @@ pk1() {
   pid=($(pgrep -f "$*"))
   case ${#pid[@]} in
     1)
-      ps -F $pid
-      m kill $pid
+      # shellcheck disable=SC2128
+      {
+        ps -F $pid
+        m kill $pid
+      }
       ;;
     0) echo "no pid found" ;;
     *)
@@ -1346,7 +1409,7 @@ pick-trash() {
   while name="$( echo | restore-trash | gr "$PWD/[^/]\+$" | gr "$1" )" \
       && [[ $name ]] && (( $(wc -l <<<"$name") >= nth )); do
     name="$(echo "$name" | head -n $nth | tail -n 1 )"
-    read -p "$name [Y/n] " ask
+    read -r -p "$name [Y/n] " ask
     if [[ ! $ask || $ask == [Yy] ]]; then
       x=$( echo "$name"  | gr -o "^\s*[0-9]*" )
       echo $x | restore-trash > /dev/null
@@ -1410,13 +1473,22 @@ q() { # start / launch a program in the backround and redir output to null
   "$@" &> /dev/null &
 }
 
+# shellcheck disable=SC2120
 r() {
-  exit "$@" 2>/dev/null
+  history -a # save history
+  exit ${1:0}
+  # i had this redir, not sure why
+  #  exit "$@" 2>/dev/null
 }
 
 rbpipe() { rbt post -o --diff-filename=- "$@"; }
 rbp() { rbt post -o "$@"; }
 
+rebr() {
+  s ifdown br0
+  s ifup br0
+}
+
 resolvcat() {
   local f
   f=/etc/resolv.conf
@@ -1450,11 +1522,9 @@ rlt() {
 rlu() { # [OPTS] HOST PATH
   # eg. rlu -opts frodo /testpath
   # relative paths will expanded with readlink -f.
-  # useful for selectively sending dirs which have been synced with unison,
-  # where the path is the same on both hosts.
   opts=("${@:1:$#-2}") #  1 to last -2
-  path="${@:$#}" # last
-  host="${@:$#-1:1}" # last -1
+  path="${*:$#}" # last
+  host="${*:$#-1:1}" # last -1
   if [[ $path == .* ]]; then
     path=$(readlink -f $path)
   fi
@@ -1486,11 +1556,13 @@ r2e() { command r2e -d /p/c/rss2email.json -c /p/c/rss2email.cfg "$@"; }
 
 rspicy() { # usage: HOST DOMAIN
   # connect to spice vm remote host. use vspicy for local host
-  local port=$(ssh $1<<EOF
+  local port
+  # shellcheck disable=SC2087
+  port=$(ssh $1<<EOF
 sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
        sed -rn "s/.*port='([0-9]+).*/\1/p"
 EOF
-        )
+      )
   if [[ $port ]]; then
     spicy -h $1 -p $port
   else
@@ -1524,7 +1596,7 @@ safe_rename() { # warn and dont rename if file exists.
     echo safe_rename error: $# args, need 2 >2
     return 1
   fi
-  if [[ $1 != $2 ]]; then # yes, we want to silently ignore this
+  if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
     if [[ -e $2 || -L $2 ]]; then
       echo "Cannot rename $1 to $2 as it already exists."
     else
@@ -1565,16 +1637,6 @@ srestart() {
     systemctl restart $service
   fi
 }
-stopnm() {
-  ser stop NetworkManager
-  ser stop dnsmasq
-  s resolvconf -d NetworkManager
-  ser start dnsmasq
-}
-startnm() {
-  ser start NetworkManager
-  s nmtui-connect
-}
 
 setini() { # set a value in a .ini style file
   key="$1" value="$2" section="$3" file="$4"
@@ -1606,17 +1668,23 @@ sgo() { # service go
   fi
 }
 
+sgu() {
+  systemctl list-unit-files | rg "$@"
+}
 
-shellck() {
-  # 2086 = unquoted $var
-  # 2046 = unquoted $(cmd)
+sk() {
+  # 2086: unquoted $var
+  # 2046: unquoted $(cmd)
+  # 2068: Double quote array expansions to avoid re-splitting elements.
+  # 2119: Functions with optional args get bad warnings when none are passed.
+  # 2033: too many false positives for thing that will never work, passing shell function to find.
   # i had -x as an arg, but debian testing(stretch) doesn\'t support it
-  shellcheck -e 2086,2046,2068,2006,2119 "$@"
+  shellcheck -x -e 2086,2046,2068,2119,2033 "$@"
+  # had this before. not sure what it is 2119
 }
 
 skaraoke() {
   local tmp out
-  in="$1"
   out=${2:-${1%.*}.sh}
   tmp=$(mktemp -d)
   script -t -c "mpv --no-config --no-resume-playback --no-terminal --no-audio-display '$1'" $tmp/typescript 2>$tmp/timing
@@ -1664,7 +1732,7 @@ slog() {
       t ) do_stamp=true ;;
     esac
   done
-  shift $(($OPTIND - 1))
+  shift $((OPTIND - 1))
   arg_base+=$1
   [[ -e $logdir ]] || mkdir -p $logdir
   $do_stamp && arg_base+=$(date +%F.%T%z)
@@ -1676,7 +1744,7 @@ splay() { # script replay
   scriptreplay "$1.t" "$1.s"
 }
 
-smeld() { # usage host1 host2 file
+smeld() { # ssh meld usage host1 host2 file
   meld <(ssh $1 cat $3) <(ssh $2 cat $3)
 }
 
@@ -1704,9 +1772,12 @@ srm () {
 
 srun() {
   scp $2 $1:/tmp
-  ssh $1 /tmp/${2##*/} "${@:2}"
+  ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
 }
 
+ssh() {
+  BASH_LOGIN_SHELL=true command ssh "$@"
+}
 sss() { # ssh solo
   ssh -oControlMaster=no -oControlPath=/ "$@"
 }
@@ -1738,7 +1809,7 @@ t() {
         args+=("$x")
       fi
     done
-    [[ ! ${args[@]} ]] || trash-put "${args[@]}"
+    (( ! ${#args[@]} )) || trash-put "${args[@]}"
   else
     rm -rf "$@"
   fi
@@ -1746,6 +1817,7 @@ t() {
 
 
 tclock() {
+  local x
   clear
   date +%l:%_M
   len=60
@@ -1800,9 +1872,8 @@ testmail() {
   # MSG_ID is in /var/log/exim4/mainlog, looks like 1ccdnD-0001nh-EN
 }
 
-# to test sieve, use below command. for fsf mail, see fsf-get-mail script.
+# to test sieve, use below command. for fsf mail, see offlineimap-sync script
 # make modifications, then copy to live file, use -eW to actually modify mailbox
-# cp /p/c/subdir_files/sieve/personal{test,}.sieve; testsievelist -eW INBOX
 #
 # Another option is to use sieve-test SCRIPT MAIL_FILE. note,
 # sieve-test doesnt know about envelopes, Im not sure if sieve-filter does.
@@ -1810,15 +1881,17 @@ testmail() {
 # sieve with output filter. arg is mailbox, like INBOX.
 # This depends on dovecot conf, notably mail_location in /etc/dovecot/conf.d/10-mail.conf
 
-testsievelist() {
-  sieve-filter ~/sieve/maintest.sieve "$@" >/tmp/testsieve.log 2> >(tail) && sed -rn '/^Performed actions:/{n;n;p}' /tmp/testsieve.log | sort -u
+_dosieve() {
+  sieve-filter "$@" 2> >(head; tail) >/tmp/testsieve.log  && sed -rn '/^Performed actions:/,/^[^ ]/{/^ /p}' /tmp/testsieve.log | sort | uniq -c
 }
 
-
-# mail related
-# plain sieve
+# always run this first, edit the test files, then run the following
 testsieve() {
-  sieve-filter ~/sieve/main.sieve "$@"
+  _dosieve ~/sieve/maintest.sieve ${1:-INBOX} delete
+}
+runsieve() {
+  c ~/sieve; cp personal{test,}.sieve; cp lists{test,}.sieve; cp personalend{test,}.sieve
+  _dosieve ~/sieve/main.sieve -eW ${1:-INBOX} delete
 }
 
 # mail related
@@ -1862,7 +1935,7 @@ tk() {
 tm() {
   # timer in minutes
   # --no-config
-  (sleep $(calc "$@ * 60") && mpv --no-config --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
+  (sleep $(calc "$* * 60") && mpv --no-config --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
 }
 
 trg() { transmission-remote-gtk&r; }
@@ -1874,12 +1947,13 @@ trc() {
 
 
 tu() {
-  local s;
-  local dir="$(dirname "$1")"
+  local s dir
+  dir="$(dirname "$1")"
   if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
     s=s;
   fi
-  $s teeu "$@"
+  # full path for using in some initial setup steps
+  $s /a/exe/teeu "$@"
 }
 
 tx() { # toggle set -x, and the prompt so it doesnt spam
@@ -1911,7 +1985,7 @@ psnetns() {
   netns=$1
   ps -w | head -n 1
   s find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
-    while read l; do
+    while read -r l; do
       x=$(ps -w --no-headers -p $l);
       if [[ $x ]]; then echo "$x"; else echo $l; fi;
     done
@@ -1919,7 +1993,6 @@ psnetns() {
 
 m() { printf "%s\n" "$*";  "$@"; }
 
-
 vpncmd() {
   #m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*pia.conf") -n -m "$@"
   m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*client.conf") -n -m "$@"
@@ -1941,7 +2014,8 @@ virshrm() {
 }
 
 vm-set-listen(){
-  local t=$(mktemp)
+  local t
+  t=$(mktemp)
   local vm=$1
   local ip=$2
   s virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
@@ -2009,22 +2083,7 @@ wian() {
 
 wtr() { curl wttr.in/boston; }
 
-xl() {
-  if pgrep gnome-screensav &>/dev/null; then
-    # this command actually starts gnome-screensaver if it isn\'t running.
-    # lololol, what crap
-    gnome-screensaver-command --exit &>/dev/null
-  fi
-  mate-screensaver-command --exit &>/dev/null
-  if ! pidof xscreensaver; then
-    pushd /
-    xscreensaver &
-    popd
-    # 1 was not long enough
-    sleep 3
-  fi
-  xscreensaver-command -activate
-}
+xevkb() { xev -event keyboard; }
 
 # * misc stuff
 
@@ -2073,44 +2132,18 @@ match_lhs=""
 
 if ${use_color} && [[ $- == *i* ]]; then
 
-  if [[ $XTERM_VERSION == Cygwin* ]]; then
-    get_term_color() {
-      for x in "$@"; do
-        case $x in
-         underl) echo -n $'\E[4m' ;;
-         bold) echo -n $'\E[1m' ;;
-         red) echo -n $'\E[31m' ;;
-         green) echo -n $'\E[32m' ;;
-         blue) echo -n $'\E[34m' ;;
-         cyan) echo -n $'\E[36m' ;;
-         yellow) echo -n $'\E[33m' ;;
-         purple) echo -n $'\E[35m' ;;
-         nocolor) echo -n $'\E(B\E[m' ;;
-        esac
-      done
-    }
+  term_bold="$(tput bold)"
+  term_red="$(tput setaf 1)"
+  term_green="$(tput setaf 2)"
+  term_yellow="$(tput setaf 3)"
+  term_purple="$(tput setaf 5)"
+  term_nocolor="$(tput sgr0)" # no font attributes
+
+  # unused so far. commented for shellcheck
+  # term_underl="$(tput smul)"
+  # term_blue="$(tput setaf 4)"
+  # term_cyan="$(tput setaf 6)"
 
-  else
-    get_term_color() {
-      for x in "$@"; do
-        case $x in
-         underl) echo -n $(tput smul) ;;
-         bold) echo -n $(tput bold) ;;
-         red) echo -n $(tput setaf 1) ;;
-         green) echo -n $(tput setaf 2) ;;
-         blue) echo -n $(tput setaf 4) ;;
-         cyan) echo -n $(tput setaf 6) ;;
-         yellow) echo -n $(tput setaf 3) ;;
-         purple) echo -n $(tput setaf 5) ;;
-         nocolor) echo -n $(tput sgr0) ;; # no font attributes
-        esac
-      done
-    }
-  fi
-else
-  get_term_color() {
-    :
-  }
 fi
 # Try to keep environment pollution down, EPA loves us.
 unset safe_term match_lhs use_color
@@ -2121,21 +2154,6 @@ unset safe_term match_lhs use_color
 
 
 if [[ $- == *i* ]]; then
-  # git branch/status prompt function
-  if [[ $OS != Windows_NT ]]; then
-    GIT_PS1_SHOWDIRTYSTATE=true
-  fi
-  # arch source lopip show -fcation
-  [[ -r /usr/share/git/git-prompt.sh ]] && source /usr/share/git/git-prompt.sh
-  # fedora/debian source
-  [[ -r /usr/share/git-core/contrib/completion/git-prompt.sh ]] && source /usr/share/git-core/contrib/completion/git-prompt.sh
-
-  # in case we didnt source git-prompt.sh
-  if ! declare -f __git_ps1 > /dev/null; then
-    __git_ps1() {
-      :
-    }
-  fi
 
   # this needs to come before next ps1 stuff
   # this stuff needs bash 4, feb 2009,
@@ -2153,43 +2171,39 @@ if [[ $- == *i* ]]; then
     PS1="\h $PS1"
   fi
 
+  # emacs terminal has problems if this runs slowly,
+  # so I've thrown a bunch of things at the wall to speed it up.
   prompt-command() {
     local return=$? # this MUST COME FIRST
-    local psc pst ps_char ps_color stale_subvol
+    local ps_char ps_color
     unset IFS
     history -a # save history
 
-
-
     case $return in
-      0) ps_color="$(get_term_color blue)"
+      0) ps_color="$term_purple"
          ps_char='\$'
          ;;
-      1) ps_color="$(get_term_color green)"
+      1) ps_color="$term_green"
          ps_char="$return \\$"
          ;;
-      *) ps_color="$(get_term_color yellow)"
+      *) ps_color="$term_yellow"
          ps_char="$return \\$"
          ;;
     esac
     if [[ ! -O . ]]; then # not owner
       if [[ -w . ]]; then # writable
-       ps_color="$(get_term_color bold red)"
+       ps_color="$term_bold$term_red"
       else
-       ps_color="$(get_term_color bold green)"
+       ps_color="$term_bold$term_green"
       fi
     fi
-    # I would set nullglob, but bash has had bugs where that
-    # doesnt work if not in top level.
-    if [[ -e /nocow/btrfs-stale ]] && ((`command ls -AUq /nocow/btrfs-stale|wc -l`)); then
-      ps_char="! $ps_char"
-    fi
-    if [[ ! $SSH_CLIENT && $MAIL_HOST != $HOSTNAME ]]; then
+
+    # faster than sourceing the file im guessing
+    eval $(< /dev/shm/iank-status)
+    if [[ ! $SSH_CLIENT && $MAIL_HOST != "$HOSTNAME" ]]; then
       ps_char="@ $ps_char"
     fi
-    PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
-    # emacs completion doesnt like the git prompt atm, so disabling it.
-    #PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
+    PS1="${PS1%"${PS1#*[wW]}"} \[$ps_color\]$ps_char\[$term_nocolor\] "
   }
   PROMPT_COMMAND=prompt-command
 
@@ -2199,7 +2213,7 @@ if [[ $- == *i* ]]; then
     else
       local title_escape="\033]0;"
     fi
-    if [[ $* != prompt-command ]]; then
+    if [[ $0 != prompt-command ]]; then
       echo -ne "$title_escape$USER@$HOSTNAME ${PWD/#$HOME/~} "
       printf "%s" "$*"
       echo -ne "\007"
@@ -2228,7 +2242,8 @@ reset-konsole() {
 }
 
 reset-sakura() {
-  while read k v; do
+  while -r read k v; do
+    # shellcheck disable=SC2154
     setini $k $v sakura /a/c/subdir_files/.config/sakura/sakura.conf
   done <<'EOF'
 colorset1_back rgb(33,37,39
@@ -2267,7 +2282,7 @@ EOF
 if [[ "$SUDOD" ]]; then
   cd "$SUDOD"
   unset SUDOD
-elif [[ -d /a ]] && [[ $PWD == $HOME ]] && [[ $- == *i* ]]; then
+elif [[ -d /a ]] && [[ $PWD == "$HOME" ]] && [[ $- == *i* ]]; then
   cd /a
 fi
 
@@ -2280,24 +2295,38 @@ unset IFS
 # commented until i want to use it because it
 # noticably slows bash startup
 #
-#if [[ $EUID != 0 && -e ~/.pyenv/bin ]]; then
-#  export PATH="~/.pyenv/bin:$PATH"
-#  eval "$(pyenv init -)"
-#  eval "$(pyenv virtualenv-init -)"
-#fi
 
+mypyenvinit () {
+  if [[ $EUID == 0 || ! -e ~/.pyenv/bin ]]; then
+    echo "error: dont be root. make sure pyenv is installed"
+    return 1
+  fi
+  export PATH="$HOME/.pyenv/bin:$PATH"
+  eval "$(pyenv init -)"
+  eval "$(pyenv virtualenv-init -)"
+}
 
 
 export GOPATH=$HOME/go
 path_add $GOPATH/bin
 path_add /usr/local/go/bin
 
+# I have the git repo and a release. either one should work.
+# I have both because I was trying to solve an issue that
+# turned out to be unrelated.
+# ARDUINO_PATH=/a/opt/Arduino/build/linux/work
 export ARDUINO_PATH=/a/opt/arduino-1.8.9
 
+# They want to be added to the start, but i think
+# that should be avoided unless we really need it.
 path_add --end ~/.npm-global
 
+path_add --end $HOME/.cargo/bin
+
 # taken from default changes to bashrc and bash_profile
 path_add --end $HOME/.rvm/bin
+
+# shellcheck disable=SC1090
 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
 
 export BASEFILE_DIR=/a/bin/fai-basefiles